Index: Blender.c
===================================================================
RCS file: /cvsroot/bf-blender/blender/source/blender/python/api2_2x/Blender.c,v
retrieving revision 1.26
diff -u -p -r1.26 Blender.c
--- Blender.c	23 Nov 2003 17:46:05 -0000	1.26
+++ Blender.c	10 Jan 2004 17:39:36 -0000
@@ -31,6 +31,8 @@
 
 #include "Blender.h"
 
+#include "BIF_renderwin.h"
+
 /*****************************************************************************/
 /* Global variables                                                          */
 /*****************************************************************************/
@@ -167,6 +169,18 @@ PyObject *Blender_Redraw(PyObject *self,
   }
 
   return M_Window_Redraw(self, Py_BuildValue("(i)", wintype));
+}
+
+PyObject *Blender_Render(PyObject *self, PyObject *args)
+{
+  int doanim;
+  
+  if(!PyArg_ParseTuple(args,"i",&doanim)) {
+    return EXPP_ReturnPyObjError (PyExc_TypeError,"expected int argument");
+  }
+  
+  BIF_do_render(doanim);
+  return (PythonIncRef(Py_None));
 }
 
 /*****************************************************************************/
Index: Scene.c
===================================================================
RCS file: /cvsroot/bf-blender/blender/source/blender/python/api2_2x/Scene.c,v
retrieving revision 1.17
diff -u -p -r1.17 Scene.c
--- Scene.c	12 Nov 2003 07:46:07 -0000	1.17
+++ Scene.c	10 Jan 2004 17:39:36 -0000
@@ -120,6 +120,7 @@ static PyObject *Scene_update(BPy_Scene 
 static PyObject *Scene_link(BPy_Scene *self, PyObject *args);
 static PyObject *Scene_unlink(BPy_Scene *self, PyObject *args);
 static PyObject *Scene_getRenderdir(BPy_Scene *self);
+static PyObject *Scene_setRenderdir(BPy_Scene *self, PyObject *args);
 static PyObject *Scene_getBackbufdir(BPy_Scene *self);
 static PyObject *Scene_getChildren(BPy_Scene *self);
 static PyObject *Scene_getCurrentCamera(BPy_Scene *self);
@@ -168,6 +169,8 @@ static PyMethodDef BPy_Scene_methods[] =
 					"(obj) - Unlink Object obj from this scene"},
 	{"getRenderdir", (PyCFunction)Scene_getRenderdir, METH_NOARGS,
 					"() - Return directory where rendered images are saved to"},
+	{"setRenderdir", (PyCFunction)Scene_setRenderdir, METH_VARARGS,
+					"(str) - Set directory where rendered images are saved to"},
 	{"getBackbufdir", (PyCFunction)Scene_getBackbufdir, METH_NOARGS,
 					"() - Return location of the backbuffer image"},
 	{"getChildren", (PyCFunction)Scene_getChildren, METH_NOARGS,
@@ -658,6 +661,22 @@ static PyObject *Scene_getRenderdir (BPy
 	else
 		return EXPP_ReturnPyObjError (PyExc_RuntimeError,
 						"Blender Scene was deleted!");
+}
+
+static PyObject *Scene_setRenderdir(BPy_Scene *self, PyObject *args)
+{
+  char *path;
+
+  if(self->scene) {
+    if (!PyArg_ParseTuple(args, "s", &path))
+      return (EXPP_ReturnPyObjError (PyExc_TypeError,"expected string argument"));
+
+    PyOS_snprintf(self->scene->r.pic,sizeof(self->scene->r.pic),"%s",path);
+  }
+  
+  Py_INCREF(Py_None);
+  
+  return Py_None;
 }
 
 static PyObject *Scene_getBackbufdir (BPy_Scene *self)
Index: Blender.h
===================================================================
RCS file: /cvsroot/bf-blender/blender/source/blender/python/api2_2x/Blender.h,v
retrieving revision 1.4
diff -u -p -r1.4 Blender.h
--- Blender.h	24 Jun 2003 07:18:26 -0000	1.4
+++ Blender.h	10 Jan 2004 17:39:36 -0000
@@ -61,6 +61,7 @@ extern short EXPP_releaseGlobalDict;
 PyObject *Blender_Set (PyObject *self, PyObject *args);
 PyObject *Blender_Get (PyObject *self, PyObject *args);
 PyObject *Blender_Redraw(PyObject *self, PyObject *args);
+PyObject *Blender_Render(PyObject *self, PyObject *args);
 PyObject *Blender_ReleaseGlobalDict(PyObject *self, PyObject *args);
 
 /*****************************************************************************/
@@ -93,6 +94,8 @@ char Blender_ReleaseGlobalDict_doc[] =
         to clear (non-zero int).\n\
 () -    Return the current behavior as a bool value (0 is false, 1 is true)\n";
 
+char Blender_Render_doc[] = "() - Starts rendering using the current settings\n";
+
 /*****************************************************************************/
 /* Python method structure definition.                                       */
 /*****************************************************************************/
@@ -102,6 +105,7 @@ struct PyMethodDef Blender_methods[] = {
 	{"Redraw", &Blender_Redraw, METH_VARARGS, Blender_Redraw_doc},
 	{"ReleaseGlobalDict", &Blender_ReleaseGlobalDict,
 					METH_VARARGS, Blender_ReleaseGlobalDict_doc},
+	{"Render", &Blender_Render, METH_VARARGS, Blender_Render_doc},
 	{NULL, NULL}
 };
 