Index: extern/freestyle/swig/SConscript
===================================================================
--- extern/freestyle/swig/SConscript	(revision 14804)
+++ extern/freestyle/swig/SConscript	(working copy)
@@ -27,104 +27,103 @@
 platform_linkflags = []
 
 if env['OURPLATFORM'] in ['win32-vc','win32-mingw']:
-	win_build_dir = "#" + root_build_dir + os.sep + "/bin/"
+	win_build_dir =  root_build_dir + os.sep + "bin\\"
 	print "Under Windows, swig.exe is directly copied to build (binary) directory: " + win_build_dir
-	shutil.copy ( "#" + root + "/swig.exe", win_build_dir )
-	Exit()
-
-#  Configure
-print "Configuring swig..."
-
-cflags = ['-g', '-O2', '-Wall', '-W','-ansi','-pedantic']
-defines = ['-DHAVE_CONFIG_H']
-
-swig_env.Append(CPPDEFINES = defines)
-swig_env.Append(CCFLAGS = cflags)
-swig_env.Append(CXXFLAGS = cflags)
-
-#  Compulation parameters
-
-swig_source_files_list = ([ 'CParse/cscanner.c',
-							'CParse/parser.y',
-							'CParse/templ.c',
-							'CParse/util.c',
-							'DOH/base.c',
-							'DOH/file.c',
-							'DOH/fio.c',
-							'DOH/hash.c',
-							'DOH/list.c',
-							'DOH/memory.c',
-							'DOH/string.c',
-							'DOH/void.c',
-							'Modules/allegrocl.cxx',
-							'Modules/allocate.cxx',
-							'Modules/browser.cxx',
-							'Modules/cffi.cxx',
-							'Modules/chicken.cxx',
-							'Modules/clisp.cxx',
-							'Modules/contract.cxx',
-							'Modules/csharp.cxx',
-							'Modules/directors.cxx',
-							'Modules/emit.cxx',
-							'Modules/guile.cxx',
-							'Modules/java.cxx',
-							'Modules/lang.cxx',
-							'Modules/lua.cxx',
-							'Modules/main.cxx',
-							'Modules/modula3.cxx',
-							'Modules/module.cxx',
-							'Modules/mzscheme.cxx',
-							'Modules/ocaml.cxx',
-							'Modules/octave.cxx',
-							'Modules/overload.cxx',
-							'Modules/perl5.cxx',
-							'Modules/php4.cxx',
-							'Modules/pike.cxx',
-							'Modules/python.cxx',
-							'Modules/r.cxx',
-							'Modules/ruby.cxx',
-							'Modules/s-exp.cxx',
-							'Modules/swigmain.cxx',
-							'Modules/tcl8.cxx',
-							'Modules/typepass.cxx',
-							'Modules/uffi.cxx',
-							'Modules/utils.cxx',
-							'Modules/xml.cxx',
-							'Preprocessor/cpp.c',
-							'Preprocessor/expr.c',
-							'Swig/cwrap.c',
-							'Swig/deprecate.c',
-							'Swig/error.c',
-							'Swig/fragment.c',
-							'Swig/getopt.c',
-							'Swig/include.c',
-							'Swig/misc.c',
-							'Swig/naming.c',
-							'Swig/parms.c',
-							'Swig/scanner.c',
-							'Swig/stype.c',
-							'Swig/symbol.c',
-							'Swig/tree.c',
-							'Swig/typeobj.c',
-							'Swig/typemap.c',
-							'Swig/typesys.c',
-							'Swig/warn.c',
-							'Swig/wrapfunc.c'])
-
-swig_source_files = []
-for source_file in swig_source_files_list:
-	swig_source_files.append('Source/' + source_file)
-
-includes = ['Source/CParse',
-			'Source/DOH',
-			'Source/Include',
-			'Source/Modules',
-			'Source/Preprocessor',
-			'Source/Swig' ]
-
-swig_env.BlenderProg(builddir="#"+root_build_dir+os.sep,
-					 progname='swig',
-					 sources=swig_source_files,
-					 includes=includes,
-					 libs=[],
-					 libpath='#'+root_build_dir+'/lib')
\ No newline at end of file
+	shutil.copy (  root + "/swig.exe", win_build_dir )
+else:	
+	#  Configure
+	print "Configuring swig..."
+
+	cflags = ['-g', '-O2', '-Wall', '-W','-ansi','-pedantic']
+	defines = ['-DHAVE_CONFIG_H']
+
+	swig_env.Append(CPPDEFINES = defines)
+	swig_env.Append(CCFLAGS = cflags)
+	swig_env.Append(CXXFLAGS = cflags)
+
+	#  Compulation parameters
+
+	swig_source_files_list = ([ 'CParse/cscanner.c',
+								'CParse/parser.y',
+								'CParse/templ.c',
+								'CParse/util.c',
+								'DOH/base.c',
+								'DOH/file.c',
+								'DOH/fio.c',
+								'DOH/hash.c',
+								'DOH/list.c',
+								'DOH/memory.c',
+								'DOH/string.c',
+								'DOH/void.c',
+								'Modules/allegrocl.cxx',
+								'Modules/allocate.cxx',
+								'Modules/browser.cxx',
+								'Modules/cffi.cxx',
+								'Modules/chicken.cxx',
+								'Modules/clisp.cxx',
+								'Modules/contract.cxx',
+								'Modules/csharp.cxx',
+								'Modules/directors.cxx',
+								'Modules/emit.cxx',
+								'Modules/guile.cxx',
+								'Modules/java.cxx',
+								'Modules/lang.cxx',
+								'Modules/lua.cxx',
+								'Modules/main.cxx',
+								'Modules/modula3.cxx',
+								'Modules/module.cxx',
+								'Modules/mzscheme.cxx',
+								'Modules/ocaml.cxx',
+								'Modules/octave.cxx',
+								'Modules/overload.cxx',
+								'Modules/perl5.cxx',
+								'Modules/php4.cxx',
+								'Modules/pike.cxx',
+								'Modules/python.cxx',
+								'Modules/r.cxx',
+								'Modules/ruby.cxx',
+								'Modules/s-exp.cxx',
+								'Modules/swigmain.cxx',
+								'Modules/tcl8.cxx',
+								'Modules/typepass.cxx',
+								'Modules/uffi.cxx',
+								'Modules/utils.cxx',
+								'Modules/xml.cxx',
+								'Preprocessor/cpp.c',
+								'Preprocessor/expr.c',
+								'Swig/cwrap.c',
+								'Swig/deprecate.c',
+								'Swig/error.c',
+								'Swig/fragment.c',
+								'Swig/getopt.c',
+								'Swig/include.c',
+								'Swig/misc.c',
+								'Swig/naming.c',
+								'Swig/parms.c',
+								'Swig/scanner.c',
+								'Swig/stype.c',
+								'Swig/symbol.c',
+								'Swig/tree.c',
+								'Swig/typeobj.c',
+								'Swig/typemap.c',
+								'Swig/typesys.c',
+								'Swig/warn.c',
+								'Swig/wrapfunc.c'])
+
+	swig_source_files = []
+	for source_file in swig_source_files_list:
+		swig_source_files.append('Source/' + source_file)
+
+	includes = ['Source/CParse',
+				'Source/DOH',
+				'Source/Include',
+				'Source/Modules',
+				'Source/Preprocessor',
+				'Source/Swig' ]
+
+	swig_env.BlenderProg(builddir="#"+root_build_dir+os.sep,
+						 progname='swig',
+						 sources=swig_source_files,
+						 includes=includes,
+						 libs=[],
+						 libpath='#'+root_build_dir+'/lib')
\ No newline at end of file