Index: intern/CMakeLists.txt
===================================================================
--- intern/CMakeLists.txt	(revision 19761)
+++ intern/CMakeLists.txt	(working copy)
@@ -24,10 +24,21 @@
 #
 # ***** END GPL LICENSE BLOCK *****
 
-SUBDIRS(SoundSystem string ghost guardedalloc bmfont moto container memutil decimation iksolver boolop opennl)
+ADD_SUBDIRECTORY(SoundSystem)
+ADD_SUBDIRECTORY(string)
+ADD_SUBDIRECTORY(ghost)
+ADD_SUBDIRECTORY(guardedalloc)
+ADD_SUBDIRECTORY(bmfont)
+ADD_SUBDIRECTORY(moto)
+ADD_SUBDIRECTORY(container)
+ADD_SUBDIRECTORY(memutil)
+ADD_SUBDIRECTORY(decimation)
+ADD_SUBDIRECTORY(iksolver)
+ADD_SUBDIRECTORY(boolop)
+ADD_SUBDIRECTORY(opennl)
 
 IF(WITH_ELBEEM)
-  SUBDIRS(elbeem)
+  ADD_SUBDIRECTORY(elbeem)
 ENDIF(WITH_ELBEEM)
 
-SUBDIRS(bsp)
+ADD_SUBDIRECTORY(bsp)
Index: source/gameengine/GamePlayer/CMakeLists.txt
===================================================================
--- source/gameengine/GamePlayer/CMakeLists.txt	(revision 19761)
+++ source/gameengine/GamePlayer/CMakeLists.txt	(working copy)
@@ -24,8 +24,9 @@
 #
 # ***** END GPL LICENSE BLOCK *****
 
-SUBDIRS(common ghost)
+ADD_SUBDIRECTORY(common)
+ADD_SUBDIRECTORY(ghost)
 
 IF(WITH_WEBPLUGIN) 
-  SUBDIRS(xembed)
+  ADD_SUBDIRECTORY(xembed)
 ENDIF(WITH_WEBPLUGIN)
Index: source/gameengine/CMakeLists.txt
===================================================================
--- source/gameengine/CMakeLists.txt	(revision 19761)
+++ source/gameengine/CMakeLists.txt	(working copy)
@@ -24,25 +24,23 @@
 #
 # ***** END GPL LICENSE BLOCK *****
 
-SUBDIRS(
-  BlenderRoutines
-  Converter
-  Expressions
-  GameLogic
-  Ketsji
-  Ketsji/KXNetwork
-  Network
-  Network/LoopBackNetwork
-  Physics/common
-  Physics/Dummy
-  Rasterizer
-  Rasterizer/RAS_OpenGLRasterizer
-  SceneGraph
-  Physics/Bullet
-  Physics/Sumo
-  VideoTexture
-)
+ADD_SUBDIRECTORY(BlenderRoutines)
+ADD_SUBDIRECTORY(Converter)
+ADD_SUBDIRECTORY(Expressions)
+ADD_SUBDIRECTORY(GameLogic)
+ADD_SUBDIRECTORY(Ketsji)
+ADD_SUBDIRECTORY(Ketsji/KXNetwork)
+ADD_SUBDIRECTORY(Network)
+ADD_SUBDIRECTORY(Network/LoopBackNetwork)
+ADD_SUBDIRECTORY(Physics/common)
+ADD_SUBDIRECTORY(Physics/Dummy)
+ADD_SUBDIRECTORY(Rasterizer)
+ADD_SUBDIRECTORY(Rasterizer/RAS_OpenGLRasterizer)
+ADD_SUBDIRECTORY(SceneGraph)
+ADD_SUBDIRECTORY(Physics/Bullet)
+ADD_SUBDIRECTORY(Physics/Sumo)
+ADD_SUBDIRECTORY(VideoTexture)
 
 IF(WITH_PLAYER)
-  SUBDIRS(GamePlayer)
+  ADD_SUBDIRECTORY(GamePlayer)
 ENDIF(WITH_PLAYER)
Index: source/blender/blenkernel/CMakeLists.txt
===================================================================
--- source/blender/blenkernel/CMakeLists.txt	(revision 19761)
+++ source/blender/blenkernel/CMakeLists.txt	(working copy)
@@ -66,7 +66,7 @@
 ENDIF(WITH_FFMPEG)
 
 IF(WITH_PLAYER)
-  SUBDIRS(bad_level_call_stubs)
+  ADD_SUBDIRECTORY(bad_level_call_stubs)
 ENDIF(WITH_PLAYER)
 
 BLENDERLIB(bf_blenkernel "${SRC}" "${INC}")
Index: source/blender/makesdna/CMakeLists.txt
===================================================================
--- source/blender/makesdna/CMakeLists.txt	(revision 19761)
+++ source/blender/makesdna/CMakeLists.txt	(working copy)
@@ -24,4 +24,4 @@
 #
 # ***** END GPL LICENSE BLOCK *****
 
-SUBDIRS(intern)
+ADD_SUBDIRECTORY(intern)
Index: source/blender/CMakeLists.txt
===================================================================
--- source/blender/CMakeLists.txt	(revision 19761)
+++ source/blender/CMakeLists.txt	(working copy)
@@ -24,20 +24,35 @@
 #
 # ***** END GPL LICENSE BLOCK *****
 
-SUBDIRS(avi nodes blenkernel blenlib blenloader blenpluginapi imbuf imbuf/intern/cineon gpu makesdna python radiosity readblenfile render src yafray)
+ADD_SUBDIRECTORY(avi)
+ADD_SUBDIRECTORY(nodes)
+ADD_SUBDIRECTORY(blenkernel)
+ADD_SUBDIRECTORY(blenlib)
+ADD_SUBDIRECTORY(blenloader)
+ADD_SUBDIRECTORY(blenpluginapi)
+ADD_SUBDIRECTORY(imbuf)
+ADD_SUBDIRECTORY(imbuf/intern/cineon)
+ADD_SUBDIRECTORY(gpu)
+ADD_SUBDIRECTORY(makesdna)
+ADD_SUBDIRECTORY(python)
+ADD_SUBDIRECTORY(radiosity)
+ADD_SUBDIRECTORY(readblenfile)
+ADD_SUBDIRECTORY(render)
+ADD_SUBDIRECTORY(src)
+ADD_SUBDIRECTORY(yafray)
 
 IF(WITH_INTERNATIONAL)
-  SUBDIRS(ftfont)
+  ADD_SUBDIRECTORY(ftfont)
 ENDIF(WITH_INTERNATIONAL)
 
 IF(WITH_OPENEXR)
-  SUBDIRS(imbuf/intern/openexr)
+  ADD_SUBDIRECTORY(imbuf/intern/openexr)
 ENDIF(WITH_OPENEXR)
 
 IF(WITH_DDS)
-  SUBDIRS(imbuf/intern/dds)
+  ADD_SUBDIRECTORY(imbuf/intern/dds)
 ENDIF(WITH_DDS)
 
 IF(WITH_QUICKTIME)
-  SUBDIRS(quicktime)
+  ADD_SUBDIRECTORY(quicktime)
 ENDIF(WITH_QUICKTIME)
Index: source/CMakeLists.txt
===================================================================
--- source/CMakeLists.txt	(revision 19761)
+++ source/CMakeLists.txt	(working copy)
@@ -24,12 +24,13 @@
 #
 # ***** END GPL LICENSE BLOCK *****
 
-SUBDIRS(blender kernel)
+ADD_SUBDIRECTORY(blender)
+ADD_SUBDIRECTORY(kernel)
 
 IF(WITH_GAMEENGINE)
-   SUBDIRS(gameengine)
+   ADD_SUBDIRECTORY(gameengine)
 ENDIF(WITH_GAMEENGINE)
 	
 IF(WINDOWS)
-   SUBDIRS(icons)
+   ADD_SUBDIRECTORY(icons)
 ENDIF(WINDOWS)
Index: extern/verse/dist/CMakeLists.txt
===================================================================
--- extern/verse/dist/CMakeLists.txt	(revision 19761)
+++ extern/verse/dist/CMakeLists.txt	(working copy)
@@ -24,7 +24,7 @@
 #
 # ***** END GPL LICENSE BLOCK *****
 
-SUBDIRS(mkprot_cmd)
+ADD_SUBDIRECTORY(mkprot_cmd)
 
 SET(SRC_MKPROT_OUT
   v_gen_pack_init.c
Index: extern/verse/CMakeLists.txt
===================================================================
--- extern/verse/CMakeLists.txt	(revision 19761)
+++ extern/verse/CMakeLists.txt	(working copy)
@@ -24,5 +24,5 @@
 #
 # ***** END GPL LICENSE BLOCK *****
 
-SUBDIRS(dist)
+ADD_SUBDIRECTORY(dist)
 
Index: extern/bullet2/src/CMakeLists.txt
===================================================================
--- extern/bullet2/src/CMakeLists.txt	(revision 19761)
+++ extern/bullet2/src/CMakeLists.txt	(working copy)
@@ -1 +1,4 @@
-SUBDIRS( BulletCollision BulletDynamics LinearMath BulletSoftBody )
+ADD_SUBDIRECTORY(BulletCollision)
+ADD_SUBDIRECTORY(BulletDynamics)
+ADD_SUBDIRECTORY(LinearMath)
+ADD_SUBDIRECTORY(BulletSoftBody )
Index: extern/CMakeLists.txt
===================================================================
--- extern/CMakeLists.txt	(revision 19761)
+++ extern/CMakeLists.txt	(working copy)
@@ -25,27 +25,27 @@
 # ***** END GPL LICENSE BLOCK *****
 
 IF(WITH_GAMEENGINE)
-  SUBDIRS(qhull solid)
+  ADD_SUBDIRECTORY(qhull solid)
 ENDIF(WITH_GAMEENGINE)
 
 IF(WITH_BULLET)
-  SUBDIRS(bullet2)
+  ADD_SUBDIRECTORY(bullet2)
 ENDIF(WITH_BULLET)
 
 IF(WITH_INTERNATIONAL)
-  SUBDIRS(bFTGL)
+  ADD_SUBDIRECTORY(bFTGL)
 ENDIF(WITH_INTERNATIONAL)
 
 IF(WITH_VERSE)
-  SUBDIRS(verse)
+  ADD_SUBDIRECTORY(verse)
 ENDIF(WITH_VERSE)
 
 IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
-  SUBDIRS(binreloc)
+  ADD_SUBDIRECTORY(binreloc)
 ENDIF(CMAKE_SYSTEM_NAME MATCHES "Linux")
 
-SUBDIRS(glew)
+ADD_SUBDIRECTORY(glew)
 
 IF(WITH_OPENJPEG)
-  SUBDIRS(libopenjpeg)
+  ADD_SUBDIRECTORY(libopenjpeg)
 ENDIF(WITH_OPENJPEG)
Index: CMakeLists.txt
===================================================================
--- CMakeLists.txt	(revision 19761)
+++ CMakeLists.txt	(working copy)
@@ -464,20 +464,18 @@
 #-----------------------------------------------------------------------------
 # Libraries
 FILE(WRITE ${CMAKE_BINARY_DIR}/cmake_blender_libs.txt "")
-SUBDIRS(
-  intern
-  extern
-  source
-)
+ADD_SUBDIRECTORY(intern)
+ADD_SUBDIRECTORY(extern)
+ADD_SUBDIRECTORY(source)
 
 
 #-----------------------------------------------------------------------------
 # Blender Application
-SUBDIRS(source/creator)
+ADD_SUBDIRECTORY(source/creator)
 
 
 #-----------------------------------------------------------------------------
 # Blender Player
 IF(WITH_PLAYER)
-  SUBDIRS(blenderplayer)
+  ADD_SUBDIRECTORY(blenderplayer)
 ENDIF(WITH_PLAYER)